diff -uNrp linuxppc-2.6.10rc3/arch/ppc/kernel/head_booke.h linuxppc-2.6.10rc3-adeos/arch/ppc/kernel/head_booke.h
--- linuxppc-2.6.10rc3/arch/ppc/kernel/head_booke.h	2004-12-06 17:14:45.000000000 +0100
+++ linuxppc-2.6.10rc3-adeos/arch/ppc/kernel/head_booke.h	2005-01-01 18:19:37.000000000 +0100
@@ -228,6 +228,12 @@ label:
 	EXC_XFER_TEMPLATE(hdlr, n+1, MSR_KERNEL, NOCOPY, transfer_to_handler, \
 			  ret_from_except)
 
+#ifdef CONFIG_ADEOS_CORE
+#define EXC_XFER_ADEOS_LITE(n, hdlr)		\
+	EXC_XFER_TEMPLATE(hdlr, n+1, MSR_KERNEL, NOCOPY, transfer_to_handler, \
+			  __adeos_ret_from_except)
+#endif /* CONFIG_ADEOS_CORE */
+
 #define EXC_XFER_EE(n, hdlr)		\
 	EXC_XFER_TEMPLATE(hdlr, n, MSR_KERNEL, COPY_EE, transfer_to_handler_full, \
 			  ret_from_except_full)
diff -uNrp linuxppc-2.6.10rc3/arch/ppc/kernel/head_e500.S linuxppc-2.6.10rc3-adeos/arch/ppc/kernel/head_e500.S
--- linuxppc-2.6.10rc3/arch/ppc/kernel/head_e500.S	2004-12-06 17:16:51.000000000 +0100
+++ linuxppc-2.6.10rc3-adeos/arch/ppc/kernel/head_e500.S	2005-01-01 18:19:37.000000000 +0100
@@ -473,7 +473,11 @@ interrupt_base:
 	EXC_XFER_EE_LITE(0x0400, handle_page_fault)
 
 	/* External Input Interrupt */
+#ifdef CONFIG_ADEOS_CORE
+	EXCEPTION(0x0500, ExternalInput, __adeos_grab_irq, EXC_XFER_ADEOS_LITE)
+#else /* !CONFIG_ADEOS_CORE */
 	EXCEPTION(0x0500, ExternalInput, do_IRQ, EXC_XFER_LITE)
+#endif /* CONFIG_ADEOS_CORE */
 
 	/* Alignment Interrupt */
 	START_EXCEPTION(Alignment)
@@ -508,7 +512,11 @@ interrupt_base:
 	lis     r0,TSR_DIS@h            /* Setup the DEC interrupt mask */
 	mtspr   SPRN_TSR,r0		/* Clear the DEC interrupt */
 	addi    r3,r1,STACK_FRAME_OVERHEAD
+#ifdef CONFIG_ADEOS_CORE
+	EXC_XFER_ADEOS_LITE(0x0900, __adeos_grab_timer)
+#else /* !CONFIG_ADEOS_CORE */
 	EXC_XFER_LITE(0x0900, timer_interrupt)
+#endif /* CONFIG_ADEOS_CORE */
 
 	/* Fixed Internal Timer Interrupt */
 	/* TODO: Add FIT support */
diff -uNrp linuxppc-2.6.10rc3/arch/ppc/kernel/idle.c linuxppc-2.6.10rc3-adeos/arch/ppc/kernel/idle.c
--- linuxppc-2.6.10rc3/arch/ppc/kernel/idle.c	2004-12-06 17:14:40.000000000 +0100
+++ linuxppc-2.6.10rc3-adeos/arch/ppc/kernel/idle.c	2005-01-01 18:19:37.000000000 +0100
@@ -39,6 +39,9 @@ void default_idle(void)
 	powersave = ppc_md.power_save;
 
 	if (!need_resched()) {
+#ifdef CONFIG_ADEOS_CORE
+		adeos_suspend_domain();
+#endif /* CONFIG_ADEOS_CORE */
 		if (powersave != NULL)
 			powersave();
 #ifdef CONFIG_SMP
diff -uNrp linuxppc-2.6.10rc3/arch/ppc/kernel/ppc_ksyms.c linuxppc-2.6.10rc3-adeos/arch/ppc/kernel/ppc_ksyms.c
--- linuxppc-2.6.10rc3/arch/ppc/kernel/ppc_ksyms.c	2005-01-19 12:15:04.000000000 +0100
+++ linuxppc-2.6.10rc3-adeos/arch/ppc/kernel/ppc_ksyms.c	2005-02-14 11:54:42.000000000 +0100
@@ -346,3 +346,28 @@ EXPORT_SYMBOL(agp_special_page);
 EXPORT_SYMBOL(__mtdcr);
 EXPORT_SYMBOL(__mfdcr);
 #endif
+
+#ifdef CONFIG_ADEOS_CORE
+/* The following are per-platform convenience exports which are needed
+   by some Adeos domains loaded as kernel modules. */
+EXPORT_SYMBOL(__switch_to);
+void show_stack(struct task_struct *task,
+		unsigned long *esp);
+EXPORT_SYMBOL(show_stack);
+void atomic_set_mask(unsigned long mask,
+		     unsigned long *ptr);
+EXPORT_SYMBOL(atomic_set_mask);
+void atomic_clear_mask(unsigned long mask,
+		       unsigned long *ptr);
+EXPORT_SYMBOL(atomic_clear_mask);
+extern unsigned long context_map[];
+EXPORT_SYMBOL(context_map);
+EXPORT_SYMBOL(_switch);
+#ifdef FEW_CONTEXTS
+EXPORT_SYMBOL(nr_free_contexts);
+EXPORT_SYMBOL(context_mm);
+EXPORT_SYMBOL(steal_context);
+#endif
+extern struct task_struct *last_task_used_math;
+EXPORT_SYMBOL(last_task_used_math);
+#endif /* CONFIG_ADEOS_CORE */
diff -uNrp linuxppc-2.6.10rc3/arch/ppc/kernel/traps.c linuxppc-2.6.10rc3-adeos/arch/ppc/kernel/traps.c
--- linuxppc-2.6.10rc3/arch/ppc/kernel/traps.c	2004-12-06 17:15:14.000000000 +0100
+++ linuxppc-2.6.10rc3-adeos/arch/ppc/kernel/traps.c	2005-01-01 18:19:37.000000000 +0100
@@ -509,6 +509,12 @@ void ProgramCheckException(struct pt_reg
 		int code = 0;
 		u32 fpscr;
 
+#ifdef CONFIG_ADEOS_CORE
+		if (__adeos_event_monitors[ADEOS_FPU_TRAP] > 0 &&
+		    __adeos_handle_event(ADEOS_FPU_TRAP,regs) != 0)
+		    return;
+#endif /* CONFIG_ADEOS_CORE */
+
 		/* We must make sure the FP state is consistent with
 		 * our MSR_FP in regs
 		 */
@@ -581,6 +587,13 @@ void AlignmentException(struct pt_regs *
 		regs->nip += 4;	/* skip over emulated instruction */
 		return;
 	}
+
+#ifdef CONFIG_ADEOS_CORE
+	if (__adeos_event_monitors[ADEOS_ALIGNMENT_TRAP] > 0 &&
+	    __adeos_handle_event(ADEOS_ALIGNMENT_TRAP,regs) != 0)
+	    return;
+#endif /* CONFIG_ADEOS_CORE */
+
 	if (fixed == -EFAULT) {
 		/* fixed == -EFAULT means the operand address was bad */
 		if (user_mode(regs))
@@ -680,6 +693,12 @@ void AltivecUnavailException(struct pt_r
 {
 	static int kernel_altivec_count;
 
+#ifdef CONFIG_ADEOS_CORE
+	if (__adeos_event_monitors[ADEOS_NOALTIVEC_TRAP] > 0 &&
+	    __adeos_handle_event(ADEOS_NOALTIVEC_TRAP,regs) != 0)
+	    return;
+#endif /* CONFIG_ADEOS_CORE */
+
 #ifndef CONFIG_ALTIVEC
 	if (user_mode(regs)) {
 		/* A user program has executed an altivec instruction,
diff -uNrp linuxppc-2.6.10rc3/arch/ppc/mm/fault.c linuxppc-2.6.10rc3-adeos/arch/ppc/mm/fault.c
--- linuxppc-2.6.10rc3/arch/ppc/mm/fault.c	2004-12-06 17:15:20.000000000 +0100
+++ linuxppc-2.6.10rc3-adeos/arch/ppc/mm/fault.c	2005-01-01 18:19:37.000000000 +0100
@@ -332,6 +332,21 @@ bad_page_fault(struct pt_regs *regs, uns
 		return;
 	}
 
+#ifdef CONFIG_ADEOS_CORE
+	/* On PPC, we only fire the Adeos trap handler when no fixup
+	   is available and the trap is endangering the kernel; IOW,
+	   it's only there to implement last chance / panic
+	   handling. */
+	if (__adeos_event_monitors[ADEOS_ACCESS_TRAP] > 0 &&
+	    __adeos_handle_event(ADEOS_ACCESS_TRAP,regs) != 0)
+	    return;
+
+	/* Ok, since we are about to jump out of the window, make sure
+	   we'll get synchronous printk() service regardless of the
+	   current domain from now on... */
+	adeos_set_printk_sync(adp_current);
+#endif /* CONFIG_ADEOS_CORE */
+
 	/* kernel has accessed a bad area */
 #if defined(CONFIG_XMON) || defined(CONFIG_KGDB)
 	if (debugger_kernel_faults)
diff -uNrp linuxppc-2.6.10rc3/include/asm-ppc/adeos.h linuxppc-2.6.10rc3-adeos/include/asm-ppc/adeos.h
--- linuxppc-2.6.10rc3/include/asm-ppc/adeos.h	1970-01-01 01:00:00.000000000 +0100
+++ linuxppc-2.6.10rc3-adeos/include/asm-ppc/adeos.h	2005-02-14 14:00:08.000000000 +0100
@@ -0,0 +1,445 @@
+/*
+ *   include/asm-ppc/adeos.h
+ *
+ *   Copyright (C) 2004 Philippe Gerum.
+ *
+ *   Adeos/PPC port over 2.6 based on the previous 2.4 implementation by:
+ *
+ *   Copyright (C) 2004 Wolfgang Grandegger.
+ *
+ *   It follows closely the ARM and x86 ports of ADEOS.
+ *
+ *   Copyright (C) 2002 Philippe Gerum.
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation, Inc., 675 Mass Ave, Cambridge MA 02139,
+ *   USA; either version 2 of the License, or (at your option) any later
+ *   version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+ */
+
+#ifndef __PPC_ADEOS_H
+#define __PPC_ADEOS_H
+
+#include <asm/ptrace.h>
+#include <asm/irq.h>
+#include <asm/bitops.h>
+#include <linux/list.h>
+#include <linux/cpumask.h>
+#include <linux/threads.h>
+
+#define ADEOS_ARCH_STRING     "r6c12/ppc"
+#define ADEOS_MAJOR_NUMBER    6
+#define ADEOS_MINOR_NUMBER    12
+
+#define ADEOS_IRQ_ACKED		0x1000
+#define ADEOS_IRQ_ACKED_MASK	(ADEOS_IRQ_ACKED - 1)
+
+#ifdef CONFIG_SMP
+
+#error "Adeos/ppc: SMP not yet implemented"
+
+#define ADEOS_NR_CPUS          NR_CPUS
+#define ADEOS_CRITICAL_IPI     0
+
+#define adeos_processor_id()   (__adeos_current_threadinfo()->cpu)
+
+#define adeos_declare_cpuid    int cpuid
+#define adeos_load_cpuid()     do { \
+                                  (cpuid) = adeos_processor_id();	\
+                               } while(0)
+#define adeos_lock_cpu(flags)  do { \
+                                  adeos_hw_local_irq_save(flags); \
+                                  (cpuid) = adeos_processor_id(); \
+                               } while(0)
+#define adeos_unlock_cpu(flags) adeos_hw_local_irq_restore(flags)
+#define adeos_get_cpu(flags)    adeos_lock_cpu(flags)
+#define adeos_put_cpu(flags)    adeos_unlock_cpu(flags)
+#define adp_current             (adp_cpu_current[adeos_processor_id()])
+
+#else  /* !CONFIG_SMP */
+
+#define ADEOS_NR_CPUS          1
+#define adeos_processor_id()   0
+/* Array references using this index should be optimized out. */
+#define adeos_declare_cpuid    const int cpuid = 0
+#define adeos_load_cpuid()      /* nop */
+#define adeos_lock_cpu(flags)   adeos_hw_local_irq_save(flags)
+#define adeos_unlock_cpu(flags) adeos_hw_local_irq_restore(flags)
+#define adeos_get_cpu(flags)    do { flags = flags; } while(0)
+#define adeos_put_cpu(flags)    /* nop */
+#define adp_current             (adp_cpu_current[0])
+
+#endif /* CONFIG_SMP */
+
+ /* PPC traps */
+#define ADEOS_ACCESS_TRAP     0
+#define ADEOS_ALIGNMENT_TRAP  1
+#define ADEOS_NOALTIVEC_TRAP  2
+#define ADEOS_FPU_TRAP        3
+#define ADEOS_NR_FAULTS       4
+/* Pseudo-vectors used for kernel events */
+#define ADEOS_FIRST_KEVENT      ADEOS_NR_FAULTS
+#define ADEOS_SYSCALL_PROLOGUE  (ADEOS_FIRST_KEVENT)
+#define ADEOS_SYSCALL_EPILOGUE  (ADEOS_FIRST_KEVENT + 1)
+#define ADEOS_SCHEDULE_HEAD     (ADEOS_FIRST_KEVENT + 2)
+#define ADEOS_SCHEDULE_TAIL     (ADEOS_FIRST_KEVENT + 3)
+#define ADEOS_ENTER_PROCESS     (ADEOS_FIRST_KEVENT + 4)
+#define ADEOS_EXIT_PROCESS      (ADEOS_FIRST_KEVENT + 5)
+#define ADEOS_SIGNAL_PROCESS    (ADEOS_FIRST_KEVENT + 6)
+#define ADEOS_KICK_PROCESS      (ADEOS_FIRST_KEVENT + 7)
+#define ADEOS_RENICE_PROCESS    (ADEOS_FIRST_KEVENT + 8)
+#define ADEOS_USER_EVENT        (ADEOS_FIRST_KEVENT + 9)
+#define ADEOS_LAST_KEVENT       (ADEOS_USER_EVENT)
+
+#define ADEOS_NR_EVENTS         (ADEOS_LAST_KEVENT + 1)
+
+typedef struct adevinfo {
+
+    unsigned domid;
+    unsigned event;
+    void *evdata;
+
+    volatile int propagate;	/* Private */
+
+} adevinfo_t;
+
+typedef struct adsysinfo {
+
+    int ncpus;			/* Number of CPUs on board */
+
+    u64 cpufreq;		/* CPU frequency (in Hz) */
+
+    /* Arch-dependent block */
+
+    struct {
+	unsigned tmirq;		/* Decrementer virtual IRQ */
+	u64 tmfreq;		/* Timebase frequency */
+    } archdep;
+
+} adsysinfo_t;
+
+#define IPIPE_NR_XIRQS   NR_IRQS
+/* Number of virtual IRQs */
+#define IPIPE_NR_VIRQS   BITS_PER_LONG
+/* First virtual IRQ # */
+#define IPIPE_VIRQ_BASE  (((IPIPE_NR_XIRQS + BITS_PER_LONG - 1) / BITS_PER_LONG) * BITS_PER_LONG)
+/* Total number of IRQ slots */
+#define IPIPE_NR_IRQS     (IPIPE_VIRQ_BASE + IPIPE_NR_VIRQS)
+/* Number of indirect words needed to map the whole IRQ space. */
+#define IPIPE_IRQ_IWORDS  ((IPIPE_NR_IRQS + BITS_PER_LONG - 1) / BITS_PER_LONG)
+#define IPIPE_IRQ_IMASK   (BITS_PER_LONG - 1)
+#define IPIPE_IRQ_ISHIFT  5	/* 2^5 for 32bits arch. */
+
+#define IPIPE_IRQMASK_ANY   (~0L)
+#define IPIPE_IRQMASK_VIRT  (IPIPE_IRQMASK_ANY << (IPIPE_VIRQ_BASE / BITS_PER_LONG))
+
+/* The first virtual interrupt is reserved for the timer (see
+   __adeos_init_platform). */
+#define ADEOS_TIMER_VIRQ    IPIPE_VIRQ_BASE
+
+typedef struct adomain {
+
+    /* -- Section: offset-based references are made on these fields
+       from inline assembly code. Please don't move or reorder. */
+#ifdef CONFIG_ADEOS_THREADS
+    unsigned long esp[ADEOS_NR_CPUS];	/* Domain stack pointers */
+#endif /* CONFIG_ADEOS_THREADS */
+    void (*dswitch)(void);	/* Domain switch hook */
+    /* -- End of section. */
+
+    struct list_head p_link;	/* Link in pipeline */
+
+    struct adcpudata {
+	unsigned long status;
+	unsigned long irq_pending_hi;
+	unsigned long irq_pending_lo[IPIPE_IRQ_IWORDS];
+	unsigned irq_hits[IPIPE_NR_IRQS];
+#ifdef CONFIG_ADEOS_THREADS
+	adevinfo_t event_info;
+#endif /* CONFIG_ADEOS_THREADS */
+    } cpudata[ADEOS_NR_CPUS];
+
+    struct {
+	int (*acknowledge)(unsigned irq);
+	void (*handler)(unsigned irq);
+	unsigned long control;
+    } irqs[IPIPE_NR_IRQS];
+
+    struct {
+	void (*handler)(adevinfo_t *evinfo);
+    } events[ADEOS_NR_EVENTS];
+
+    struct adomain *m_link;	/* Link in mutex sleep queue */
+
+    unsigned long flags;
+
+    unsigned domid;
+
+    const char *name;
+
+    int priority;
+
+    int ptd_keymax;
+    int ptd_keycount;
+    unsigned long ptd_keymap;
+    void (*ptd_setfun)(int, void *);
+    void *(*ptd_getfun)(int);
+
+#ifdef CONFIG_ADEOS_THREADS
+    unsigned long estackbase[ADEOS_NR_CPUS];
+#endif /* CONFIG_ADEOS_THREADS */
+
+} adomain_t;
+
+/* The following macros must be used hw interrupts off. */
+
+#define __adeos_set_irq_bit(adp,cpuid,irq) \
+do { \
+    if (!test_bit(IPIPE_LOCK_FLAG,&(adp)->irqs[irq].control)) { \
+        __set_bit(irq & IPIPE_IRQ_IMASK,&(adp)->cpudata[cpuid].irq_pending_lo[irq >> IPIPE_IRQ_ISHIFT]); \
+        __set_bit(irq >> IPIPE_IRQ_ISHIFT,&(adp)->cpudata[cpuid].irq_pending_hi); \
+       } \
+} while(0)
+
+#define __adeos_clear_pend(adp,cpuid,irq) \
+do { \
+    __clear_bit(irq & IPIPE_IRQ_IMASK,&(adp)->cpudata[cpuid].irq_pending_lo[irq >> IPIPE_IRQ_ISHIFT]); \
+    if ((adp)->cpudata[cpuid].irq_pending_lo[irq >> IPIPE_IRQ_ISHIFT] == 0) \
+        __clear_bit(irq >> IPIPE_IRQ_ISHIFT,&(adp)->cpudata[cpuid].irq_pending_hi); \
+} while(0)
+
+#define __adeos_lock_irq(adp,cpuid,irq) \
+do { \
+    if (!test_and_set_bit(IPIPE_LOCK_FLAG,&(adp)->irqs[irq].control)) \
+	__adeos_clear_pend(adp,cpuid,irq); \
+} while(0)
+
+#define __adeos_unlock_irq(adp,irq) \
+do { \
+    if (test_and_clear_bit(IPIPE_LOCK_FLAG,&(adp)->irqs[irq].control)) { \
+        int __cpuid, __nr_cpus = num_online_cpus();	      \
+	for (__cpuid = 0; __cpuid < __nr_cpus; __cpuid++)      \
+         if ((adp)->cpudata[__cpuid].irq_hits[irq] > 0) { /* We need atomic ops next. */ \
+           set_bit(irq & IPIPE_IRQ_IMASK,&(adp)->cpudata[__cpuid].irq_pending_lo[irq >> IPIPE_IRQ_ISHIFT]); \
+           set_bit(irq >> IPIPE_IRQ_ISHIFT,&(adp)->cpudata[__cpuid].irq_pending_hi); \
+         } \
+    } \
+} while(0)
+
+#define __adeos_clear_irq(adp,irq) \
+do { \
+    int __cpuid, __nr_cpus = num_online_cpus(); \
+    clear_bit(IPIPE_LOCK_FLAG,&(adp)->irqs[irq].control); \
+    for (__cpuid = 0; __cpuid < __nr_cpus; __cpuid++) {	\
+       (adp)->cpudata[__cpuid].irq_hits[irq] = 0; \
+       __adeos_clear_pend(adp,__cpuid,irq); \
+    } \
+} while(0)
+
+#define adeos_virtual_irq_p(irq) ((irq) >= IPIPE_VIRQ_BASE && \
+				  (irq) < IPIPE_NR_IRQS)
+
+static inline void adeos_hw_local_irq_save_ptr(unsigned long *flags)
+{
+    unsigned long msr;
+    msr = mfmsr();
+    *flags = msr;
+    mtmsr(msr & ~MSR_EE);
+    __asm__ __volatile__("": : :"memory");
+}
+
+#define adeos_hw_local_irq_save_flags(flags) adeos_hw_local_irq_save_ptr(&(flags))
+#define adeos_hw_local_irq_restore(flags)    mtmsr(flags)
+
+static inline void adeos_hw_local_irq_disable(void)
+{
+    unsigned long msr;
+    msr = mfmsr();
+    mtmsr(msr & ~MSR_EE);
+    __asm__ __volatile__("": : :"memory");
+}
+
+static inline void adeos_hw_local_irq_enable(void)
+{
+    unsigned long msr;
+    __asm__ __volatile__("": : :"memory");
+    msr = mfmsr();
+    mtmsr(msr | MSR_EE);
+}
+
+#define adeos_hw_local_irq_save(flags) ({adeos_hw_local_irq_save_flags(flags);adeos_hw_local_irq_disable();})
+#define adeos_hw_save_flags_and_sti(flags) ({adeos_hw_local_irq_save_flags(flags);adeos_hw_local_irq_enable();})
+
+#define adeos_hw_cli() adeos_hw_local_irq_disable()
+#define adeos_hw_sti() adeos_hw_local_irq_enable()
+
+#define adeos_hw_local_irq_flags(flags)	asm volatile("mfmsr %0" : "=r" (flags))
+#define adeos_hw_test_iflag(x)		((x) & MSR_EE)
+#define adeos_hw_irqs_disabled()	\
+({					\
+	unsigned long flags;		\
+	adeos_hw_local_irq_flags(flags);\
+	!adeos_hw_test_iflag(flags);	\
+})
+
+/* Get the machine TSC by copying the time base registers contents to
+   the destination variable. Assuming big-endianess here. */ 
+
+#define adeos_hw_tsc(t) \
+({ unsigned long __tbu; \
+   __asm__ __volatile__ ("1: mftbu %0\n" \
+			 "mftb %1\n" \
+			 "mftbu %2\n" \
+			 "cmpw %2,%0\n" \
+			 "bne- 1b\n" \
+			 :"=r" (((unsigned long *)&t)[0]), \
+			 "=r" (((unsigned long *)&t)[1]), \
+			 "=r" (__tbu)); \
+   t; })
+
+extern unsigned tb_ticks_per_jiffy;
+
+#define adeos_cpu_freq() (HZ * tb_ticks_per_jiffy)
+
+#ifdef CONFIG_PREEMPT
+#define adeos_spin_lock(x)     _raw_spin_lock(x)
+#define adeos_spin_unlock(x)   _raw_spin_unlock(x)
+#define adeos_spin_trylock(x)  _raw_spin_trylock(x)
+#define adeos_write_lock(x)    _raw_write_lock(x)
+#define adeos_write_unlock(x)  _raw_write_unlock(x)
+#define adeos_write_trylock(x) _raw_write_trylock(x)
+#define adeos_read_lock(x)     _raw_read_lock(x)
+#define adeos_read_unlock(x)   _raw_read_unlock(x)
+#else /* !CONFIG_PREEMPT */
+#define adeos_spin_lock(x)     spin_lock(x)
+#define adeos_spin_unlock(x)   spin_unlock(x)
+#define adeos_spin_trylock(x)  spin_trylock(x)
+#define adeos_write_lock(x)    write_lock(x)
+#define adeos_write_unlock(x)  write_unlock(x)
+#define adeos_write_trylock(x) write_trylock(x)
+#define adeos_read_lock(x)     read_lock(x)
+#define adeos_read_unlock(x)   read_unlock(x)
+#endif /* CONFIG_PREEMPT */
+
+#define adeos_spin_lock_irqsave(x,flags)  \
+do { \
+   adeos_hw_local_irq_save(flags); \
+   adeos_spin_lock(x); \
+} while (0)
+
+#define adeos_spin_unlock_irqrestore(x,flags)  \
+do { \
+   adeos_spin_unlock(x); \
+   adeos_hw_local_irq_restore(flags); \
+} while (0)
+
+#define adeos_spin_lock_disable(x)  \
+do { \
+   adeos_hw_cli(); \
+   adeos_spin_lock(x); \
+} while (0)
+
+#define adeos_spin_unlock_enable(x)  \
+do { \
+   adeos_spin_unlock(x); \
+   adeos_hw_sti(); \
+} while (0)
+
+#define adeos_read_lock_irqsave(lock, flags) \
+do { \
+   adeos_hw_local_irq_save(flags); \
+   adeos_read_lock(lock); \
+} while (0)
+
+#define adeos_read_unlock_irqrestore(lock, flags) \
+do { \
+   adeos_read_unlock(lock); \
+   adeos_hw_local_irq_restore(flags); \
+} while (0)
+
+#define adeos_write_lock_irqsave(lock, flags) \
+do { \
+   adeos_hw_local_irq_save(flags); \
+   adeos_write_lock(lock); \
+} while (0)
+
+#define adeos_write_unlock_irqrestore(lock, flags) \
+do { \
+   adeos_write_unlock(lock); \
+   adeos_hw_local_irq_restore(flags); \
+} while (0)
+
+/* Private interface -- Internal use only */
+
+struct adattr;
+
+void __adeos_init(void);
+
+void __adeos_init_domain(adomain_t *adp,
+			 struct adattr *attr);
+
+void __adeos_cleanup_domain(adomain_t *adp);
+
+#define __adeos_check_platform() do { } while(0)
+
+#define __adeos_read_timebase() ({ unsigned long long t; adeos_hw_tsc(t); t; })
+
+void __adeos_init_platform(void);
+
+void __adeos_enable_pipeline(void);
+
+void __adeos_disable_pipeline(void);
+
+void __adeos_init_stage(adomain_t *adp);
+
+void __adeos_sync_stage(unsigned long syncmask);
+
+int __adeos_ack_irq(unsigned irq);
+
+void __adeos_do_IRQ(int irq,
+		    struct pt_regs *regs);
+
+void __adeos_do_timer(int irq,
+		      struct pt_regs *regs);
+
+struct thread_info *__adeos_current_threadinfo(void);
+
+#ifdef CONFIG_ADEOS_THREADS
+
+int __adeos_switch_domain(adomain_t *adp,
+			  adomain_t **currentp);
+
+/* Called with hw interrupts off. */
+static inline void __adeos_switch_to (adomain_t *out,
+				      adomain_t *in,
+				      int cpuid)
+{
+    extern adomain_t *adp_cpu_current[];
+
+    __adeos_switch_domain(in,&adp_cpu_current[cpuid]);
+
+    if (out->dswitch != NULL)
+	out->dswitch();
+}
+
+#endif /* CONFIG_ADEOS_THREADS */
+
+extern struct pt_regs __adeos_irq_regs;
+
+extern unsigned long __adeos_virtual_irq_map;
+
+extern unsigned long __adeos_decr_ticks;
+
+extern unsigned long long __adeos_decr_next[];
+
+#endif /* !__PPC_ADEOS_H */
diff -uNrp linuxppc-2.6.10rc3/include/asm-ppc/hw_irq.h linuxppc-2.6.10rc3-adeos/include/asm-ppc/hw_irq.h
--- linuxppc-2.6.10rc3/include/asm-ppc/hw_irq.h	2004-12-06 17:16:27.000000000 +0100
+++ linuxppc-2.6.10rc3-adeos/include/asm-ppc/hw_irq.h	2005-01-01 18:19:37.000000000 +0100
@@ -12,6 +12,37 @@ extern void timer_interrupt(struct pt_re
 
 #define INLINE_IRQS
 
+#ifdef CONFIG_ADEOS_CORE
+
+void __adeos_stall_root(void);
+void __adeos_unstall_root(void);
+unsigned long __adeos_test_root(void);
+unsigned long __adeos_test_and_stall_root(void);
+void __adeos_restore_root(unsigned long flags);
+
+#define irqs_disabled()  __adeos_test_root()
+
+static inline void local_irq_disable(void) {
+    __adeos_stall_root();
+}
+
+static inline void local_irq_enable(void) {
+    __adeos_unstall_root();
+}
+
+static inline void local_irq_save_ptr(unsigned long *flags) {
+    *flags = __adeos_test_and_stall_root();
+}
+
+static inline void local_irq_restore(unsigned long flags) {
+    __adeos_restore_root(flags);
+}
+
+#define local_save_flags(flags)		((flags) = __adeos_test_root())
+#define local_irq_save(flags)		local_irq_save_ptr(&flags)
+
+#else /* !CONFIG_ADEOS_CORE */
+
 #define irqs_disabled()	((mfmsr() & MSR_EE) == 0)
 
 #ifdef INLINE_IRQS
@@ -57,6 +88,8 @@ extern void local_save_flags_ptr(unsigne
 
 #endif
 
+#endif /* CONFIG_ADEOS_CORE */
+
 extern void do_lost_interrupts(unsigned long);
 
 #define mask_irq(irq) ({if (irq_desc[irq].handler && irq_desc[irq].handler->disable) irq_desc[irq].handler->disable(irq);})
diff -uNrp linuxppc-2.6.10rc3/include/asm-ppc/smp.h linuxppc-2.6.10rc3-adeos/include/asm-ppc/smp.h
--- linuxppc-2.6.10rc3/include/asm-ppc/smp.h	2004-12-06 17:15:10.000000000 +0100
+++ linuxppc-2.6.10rc3-adeos/include/asm-ppc/smp.h	2005-01-01 18:19:37.000000000 +0100
@@ -45,7 +45,12 @@ extern void smp_local_timer_interrupt(st
 #define NO_PROC_ID		0xFF            /* No processor magic marker */
 #define PROC_CHANGE_PENALTY	20
 
-#define smp_processor_id() (current_thread_info()->cpu)
+#ifdef CONFIG_ADEOS_CORE
+#include <asm/adeos.h>
+#define smp_processor_id()      adeos_processor_id()
+#else /* !CONFIG_ADEOS_CORE */
+#define smp_processor_id()	(current_thread_info()->cpu)
+#endif /* CONFIG_ADEOS_CORE */
 
 extern int __cpu_up(unsigned int cpu);
 
